'''
avlib 0.4

(c) 2003 Jan ONDREJ (SAL) <ondrejj@salstar.sk>

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
    
'''

import os,sys,re,string,time,tempfile

ROOT_PATH=''
MASTER_PID=os.getpid()
logfd=sys.stderr
from default import DEBUG_LEVEL
from config import DEBUG_LEVEL

def debug(level,*s):
    if DEBUG_LEVEL>=level:
      o=''
      for i in s:
        if type(i)==type([]):
          for x in i:
            o=o+str(x)
        else:
          o=o+str(i)
      p=os.getpid()
      if p==MASTER_PID:
        logfd.write(o+'\n')
      else:
        logfd.write("%6s: %s\n" % (p,o))
    
class popen:
  exitstatus=-1
  def __init__(self, cmd):
      self.pcr,self.pcw = os.pipe()
      self.cpr,self.cpw = os.pipe()
      self.pid = os.fork()
      if self.pid == 0: # child
        os.close(self.pcw)
        os.close(self.cpr)
        os.dup2(self.pcr,0)
        os.dup2(self.cpw,1)
        os.dup2(self.cpw,2)
        try:
          os.execvp(cmd[0],cmd)
        except os.error,(ec,es):
          sys.exit(1)
      os.close(self.pcr)
      os.close(self.cpw)
      self.tocmd=os.fdopen(self.pcw, 'w')
      self.fromcmd=os.fdopen(self.cpr, 'r')
  def wait(self):
      pid,self.exitstatus=os.waitpid(self.pid,0)
      return self.exitstatus
  def readlines(self):
      return self.fromcmd.readlines()
  def write(self,s):
      return self.tocmd.write(s)
  def close(self,rw=3):
      if rw&1:
        self.tocmd.flush()
        os.close(self.pcw)
      if rw&2:
        os.close(self.cpr)

def fromhdr():
    return "From local@local.local"+\
      time.strftime("  %c\r\n",time.localtime(time.time()))

def smktemp(s):
    global ROOT_PATH
    return ROOT_PATH+tempfile.mktemp(s)

def creatembox(file,data):
    try:
      fd=os.open(file,os.O_WRONLY|os.O_CREAT|os.O_EXCL, 0600)
      f=os.fdopen(fd,'w',4096)
      f.write("From local@local"+\
              time.strftime("  %c\n",time.localtime(time.time())))
      f.write(data)
      f.close()
    except os.error,(ec,es):
      debug(0,'creatembox: open error: ',es)
      raise
    except IOError,(ec,es):
      debug(0,'creatembox: ioerror: ',es)
      raise

def tempcleanup(file,s=''):
    try:
      os.unlink(file)
    except OSError,(er,es):
      debug(0,s+": OSError: ",es,file)

class ascanner:
  name='AScanner'
  is_spamscan=0
  def __init__(self,arg):
      self.arg=arg
  def scanstream(self,stream):
      raise 'ascanner','Not implemented'
  def scanfile(self,files,dirname=''):
      raise 'ascanner','Not implemented'

class finalscanner(ascanner):
  name=''
  S_OK='250'
  S_FAIL='451'
  def __init__(self,status='250'):
      self.status=status
  def scanstream(self,stream):
      if self.status==self.S_OK:
        return '',[]
      else:
        raise finalscanner,self.S_FAIL
  def scanfile(self,files,dirname=''):
      if self.status==self.S_OK:
        return '',[]
      else:
        raise finalscanner,self.S_FAIL
