#!/bin/sh

if [ "$1" ]; then
  export ROOTPATH="$1"
else
  export ROOTPATH=root
fi

addfile() {
  cp -f $1 $ROOTPATH/$1
}

addbin() {
  if [ -f $1 ]; then
    cp -f $1 $ROOTPATH/$1
    if ldd $1 > /dev/null; then
      for i in `ldd $1 | awk '{print $3}' | sed 's/^\/lib\/tls/\/lib/g'`; do
        addbin $i
      done
    fi
  else
    echo "Command $1 not found!"
  fi
}

adduser() {
  grep $1 /etc/passwd >> $ROOTPATH/etc/passwd
}

mkdir -p $ROOTPATH/{dev,etc,bin,lib,tmp,usr/bin,usr/lib,usr/share}
mkdir -p $ROOTPATH/tmp/quarantine

cat > $ROOTPATH/etc/nsswitch.conf <<EOF
passwd:     files
shadow:     files
group:      files

hosts:      dns

ethers:     files
netmasks:   files
networks:   files
protocols:  files
rpc:        files
services:   files
EOF

rm -f $ROOTPATH/etc/passwd
adduser root
adduser clamav
adduser vscan

echo "/usr/lib" > $ROOTPATH/etc/ld.so.conf
touch $ROOTPATH/dev/null
touch $ROOTPATH/dev/zero
dd if=/dev/urandom of=$ROOTPATH/dev/urandom bs=1024 count=10 2> /dev/null

addbin /bin/gzip
addbin /usr/bin/bzip2
if [ -x /bin/tar ]; then
  addbin /bin/tar
else
  addbin /usr/bin/tar
fi
addbin /usr/bin/unzip
addbin /usr/bin/unrar
addbin /usr/bin/unarj
addbin /usr/bin/zoo
addbin /usr/bin/lha
addbin /usr/bin/arc

addbin /usr/bin/clamscan
addfile /etc/clamav.conf
mkdir -p $ROOTPATH/usr/share/clamav
addfile /usr/share/clamav/viruses.db
addfile /usr/share/clamav/viruses.db2

ldconfig -r $ROOTPATH
