'''
mimeparse module, version 0.1

(c) 2003 Jan ONDREJ (SAL) <ondrejj@salstar.sk>
                                                                                
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

'''

from avlib import *
import os
import email,mimetypes

allowed_chars='abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789._-'

class savemail(ascanner):
      def __init__(self,dir):
          self.dir=dir
          self.filename='part-a'
      def scanstream(self,data):
          fp=open(os.path.join(self.dir,self.filename), 'wb')
          fp.write(data)
          fp.close()
          return '',[]

def decode_email(data,scanner):
    msg=email.message_from_string(data)
    files=[]
    counter=1
    vir,ret='',[]
    for part in msg.walk():
      if part.get_content_maintype()=='multipart':
        continue
      counter=counter+1
      scanner.filename=part.get_filename()
      debug(2,'FILENAME: ',scanner.filename)
      if scanner.filename:
        sfn=''
        for chp in range(len(scanner.filename)):
          if not scanner.filename[chp] in allowed_chars:
            sfn.join('_')
          else:
            sfn.join(scanner.filename[chp])
        scanner.filename=sfn
      else:
        try:
          ext = mimetypes.guess_extension(part.get_type())
        except:
          ext='.bin'
        if not ext:
          ext='.bin'
        scanner.filename = 'part-%03d%s' % (counter, ext)
      v,r=scanner.scanstream(part.get_payload(decode=1))
      files.append(scanner.filename)
      vir=vir+v
      ret=ret+r
    return vir,ret,files

class mimeparse(ascanner):
  def __init__(self,scanner):
      self.name='MimeParse('+scanner.name+')'
      self.scanner=scanner
  def scanstream(self,stream):
      mboxdir=smktemp('.mbd')
      os.mkdir(mboxdir,0770)
      vir,ret,filelist=decode_email(stream,savemail(mboxdir))
      try:
        vir,ret=self.scanner.scanfile(filelist,mboxdir)
      except:
        for f in filelist:
          os.unlink(os.path.join(mboxdir,f))
        os.rmdir(mboxdir)
        raise
      for f in filelist:
        os.unlink(os.path.join(mboxdir,f))
      os.rmdir(mboxdir)
      return vir,ret

class mimeparse_stream(ascanner):
  def __init__(self,scanner):
      self.name="MimeParse_stream("+scanner.name+")"
      self.scanner=scanner
  def scanstream(self,stream):
      vir,ret,filelist=decode_email(stream,self.scanner)
      return vir,ret
