#!/usr/bin/python

'''
sagator.py 0.3
(c) 2003 Jan ONDREJ (SAL) <ondrejj@salstar.sk>

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

'''

from config import *
from aglib import *
import signal
import avlib

def chldexit(sn,stack):
    os.wait()

def main(host,port):
    try:
      if port<0:
        dochroot(USER,GROUP,CHROOT)
        m=smtps()
        while 1:
          if m.recv(): break
        sys.stdin.close()
        sys.stdout.close()
        sys.exit(0)
      else:
        s=socket.socket(socket.AF_INET,socket.SOCK_STREAM)
        s.setsockopt(socket.SOL_SOCKET,socket.SO_REUSEADDR,1)
        try:
          s.bind((host,port))
          s.listen(2)
        except socket.gaierror,(ec,es):
          debug(0,"SERVER: BIND ERROR: ",es)
          sys.exit(1)
        dochroot(USER,GROUP,CHROOT)
        signal.signal(signal.SIGCHLD,chldexit)
        while 1:
          try:
            conn,addr = s.accept()
            pid=os.fork()
            if pid==0:
              signal.signal(signal.SIGCHLD,signal.SIG_IGN)
              debug(1,"SERVER: Connection from: "+addr[0])
              m=smtps(conn)
              while 1:
                if m.recv(): break
              conn.shutdown(2)
              debug(1,"SERVER: Closing connection.")
              sys.exit(0)
            conn.close()
          except socket.error,(en,es):
            if en==107: # 'Transport endpoint is not connected'
              debug(1,"SERVER: Connection closed by peer.")
              sys.exit(0)
            elif en==32: # 'Broken pipe'
              debug(0,"SERVER: Broken pipe.")
              sys.exit(1)
            elif en!=4:
              debug(0,'SERVER: SocketError: ',es)
              debug(0,traceback.format_exception(sys.exc_type, sys.exc_value, sys.exc_traceback))
              if en==9:
                sys.exit(1)
    except KeyboardInterrupt:
      debug(0,"SERVER: Exiting ...")
      sys.exit(0)

if __name__ == '__main__':
  host='localhost'
  port=10027
  n=1
  while n<len(sys.argv):
    if sys.argv[n]=='--help':
      print "SAGATOR 0.3"
      print "Usage: --help       this help"
      print "       --inetd      stard as inetd service (useful for postfix too)"
      print "       --host h     smtp server host"
      print "       --port p     smtp server port"
      print "       --logfile l  filename for logging"
      sys.exit(0)
    elif sys.argv[n]=='--inetd':
      host='-'
      port=-1
      n=n+1
    elif sys.argv[n]=='--host':
      host=sys.argv[n+1]
      n=n+2
    elif sys.argv[n]=='--port':
      port=string.atoi(sys.argv[n+1])
      n=n+2
    elif sys.argv[n]=='--logfile':
      avlib.logfd=open(sys.argv[n+1],'a',0)
      n=n+2
    else:
      print "Unknown parameter:", sys.argv[n]
      sys.exit(1)
  debug(0,"sagator started, waiting for connections ...")
  ss=''
  for s in SCANNERS:
    ss=ss+' '+s.name
  debug(0,"Configured scanners:",ss)
  main(host,port)
